#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

static int content_mode = 1;

void show(FILE *fout, int x, int n) {
  for (int i=0; i<n; i++) {
    int v = x % 256;
    fputc(v,fout);
    x /= 256;
  }
}

void show_header(FILE *fout, int sample_len) {
  fprintf(fout,"RIFF");
  show(fout,36+sample_len,4);
  fprintf(fout,"WAVE");
  fprintf(fout,"fmt ");
  show(fout,16,4);
  show(fout,1,2);
  show(fout,1,2);
  show(fout,16000,4);
  show(fout,16000,4);
  show(fout,1,2);
  show(fout,8,2);
  fprintf(fout,"data");
  show(fout,sample_len,4);
}

void render(FILE *fout, char *text) {
  int unit_len = 4000;
  int char_len = strlen(text);
  int sample_len = unit_len*char_len;
  show_header(fout,sample_len);

  double v = 0;
  int n_prev = 0;
  for (int i=0; i<char_len; i++) {
    int n = text[i] - '0';
    for (int j=0; j<unit_len; j++) {
      double q = 0;
      double factor = j/80.0;
      if (factor>1) { factor = 1; }
      q += factor*100*sin((1+n)*v);
      if (i!=0) {
	q += (1-factor)*100*sin((1+n_prev)*v);
      }
      show(fout,128+int(q),1);
      //show(fout,128+int(127*sin(i*0.1)),1);
      v += 0.1;
    }
    n_prev = n;
  }
}



void main(int argc, char *argv[]) {
  FILE *fout = stdout;
  char *default_text = "012343210";
  char *text = default_text;
  argc--;
  argv++;
  while (argc>0) {
    text = argv[0];
    if (text[0]=='-') {
      switch (text[1]) {
      case 'w':
	content_mode = 0;
	break;
      }
    }
    argc--;
    argv++;
  }
  if (content_mode) {
    text = default_text;
    char *data;
    data = getenv("QUERY_STRING");
    if(data != NULL) {
      if (data[0]=='s') {
	if (data[1]=='=') {
	  text = data+2;
	}
      }
    }

    printf("Content-Type: audio/x-wav");
    printf("%c%c",10,10);
  }
  render(fout,text);
}
