#!/usr/bin/perl -w

use strict;

if ($#ARGV<1) 
  {
    die "not enough arguments";
  }

my $BASEDIR = $ARGV[0];
my $BASEFILE = $ARGV[1];

open(COM,"<COMMENTS.TXT");
my $txt = "";
while(<COM>)
  {
    $txt .= $_;
  }

open(REF,"<out_all.00.unwrap");
my @ref = ();
while(<REF>)
  {
    chomp;
    push(@ref,$_);
  }

my $txt0 = $txt;
my $txt1 = $txt;
$txt0 =~ s/[\n\r]*MORE(.|[\n\r])*//;
$txt1 =~ s/(.|[\n\r])*MORE.*[\n\r]*//;
$txt0 =~ s/\n\n+/\<P\>/g;
$txt1 =~ s/\n\n+/\<P\>/g;

open(MSG,"<message-verbose.txt");
my $msg = "";
while(<MSG>)
  {
    $msg .= $_;
  }

open(AMSG,">message-verbose.html");
my $imsg = "";

print AMSG "<HTML><HEAD><TITLE>CosmicOS message</TITLE></HEAD>\n";
print AMSG "<BODY BGCOLOR='#ffffff'><TT>\n";
my $name = 0;
my $ref_index = 0;
for my $m (split(/\n/,$msg))
  {
    my $s = $m;
    $s =~ s/\&/&amp;/g;
    $s =~ s/\</&lt;/g;
    $s =~ s/\>/&gt;/g;
    my $prefix = "";
    my $postfix = "";
    my $novel = 1;
    if ($m =~ /\#  ?[A-Z][A-Z]/)
      {
	if ($s =~ /\# *([A-Z]+) *(.*)/)
	  {
	    my $sect = $1;
	    my $comment = $2;
	    $prefix = "<A NAME='$name'><FONT COLOR=red>";
	    $imsg .= "<TR><TD ALIGN=RIGHT><A HREF='message-verbose.html#$name'>$name</A> </TD><TD>&nbsp;&nbsp;</TD><TD> $comment </TD><TD> ($sect) </TD></TR>\n";
	    $name = $name+1;
	    $postfix = "</FONT>";
	  }
	$novel = 0;
      }
    if ($s =~ /^( +)/)
      {
	my $space = $1;
	$space =~ s/ /\&nbsp\;/g;
	$s =~ s/^ +/$space/;
	$novel = 0;
      }
    if ($s =~ /^\#/) { $novel = 0; }
    if ($novel) {
      print AMSG "<TT>[<A HREF='make_wave3.cgi?s=$ref[$ref_index]'>hear</A>] </TT>";
      $ref_index++;
    } else {
      print AMSG "<TT>\&nbsp;\&nbsp;\&nbsp;\&nbsp;\&nbsp;\&nbsp;\&nbsp;</TT>";
    }
    print AMSG "$prefix$s$postfix<BR>\n";
  }

$imsg = "<TABLE BORDER=0>\n$imsg</TABLE>\n";

print AMSG "</TT></BODY>\n";
print AMSG "</HTML>\n";
close(AMSG);

open(TEMPLATE,"<template.html");
my $plate = "";
while(<TEMPLATE>)
  {
    $plate .= $_;
  }

my $entropy = `cp message-stripped.txt entropy.txt; gzip -q -f entropy.txt; wc -c < entropy.txt.gz; rm -f entropy.txt.gz`;
my $imgsize = `./imgsize.pl view.png`;
$entropy = $entropy/1024;
$entropy = int(0.5+$entropy*10)/10;

$plate =~ s/XXX/$txt0/g;
$plate =~ s/MMM/$txt1/g;
$plate =~ s/DDD/$BASEDIR/g;
$plate =~ s/FFF/$BASEFILE/g;
$plate =~ s/III/$imsg/g;
$plate =~ s/EEE/$entropy/g;
$plate =~ s/SSS/$imgsize/g;

print $plate;
