

(intro lambda);


(define list-helper
  (? n
    (? ret
      (if (> (n) 1)
        (? x
          (list-helper
            (- (n) 1)
            (? y (? z (ret (+ 1 (y)) (cons (x) (z)))))))
        (? x (ret 1 (x)))))));
(define list
  (? n
    (if (= (n) 0)
      (cons 0 0)
      (list-helper (n) (? y (? z (cons (y) (z))))))));
(define head
  (? lst
    (if (= (car (lst)) 0)
      (undefined)
      (if (= (car (lst)) 1)
        (cdr (lst))
        (car (cdr (lst)))))));
(define tail
  (? lst
    (if (= (car (lst)) 0)
      (undefined)
      (if (= (car (lst)) 1)
        (cons 0 0)
        (cons (- (car (lst)) 1) (cdr (cdr (lst))))))));
(define list-length (? lst (car (lst))));
(define list-ref
  (? lst
    (? n
      (if (= (list-ref (lst)) 0)
        (undefined)
        (if (= (n) 0)
          (head (lst))
          (list-ref (tail (lst)) (- (n) 1)))))));
(define prepend
  (? x
    (? lst
      (if (= (list-length (lst)) 0)
        (cons 1 (x))
        (cons (+ (list-length (lst)) 1)
              (cons (x) (cdr (lst))))))));
(define list=
  (? x
    (? y
      (if (= (list-length (x)) (list-length (y)))
        (if (> (list-length (x)) 0)
          (and (= (head (x)) (head (y)))
               (list= (tail (x)) (tail (y))))
          (true))
        (false)))));
(define pair (? x (? y ((list 2) (x) (y)))));

(define base-translate (translate));
(define translate
  (? x (if (= (x) 10) 15 (base-translate (x)))));
(= 10 15);
(= (+ 10 15) 30);
(define translate (base-translate));
(not (= 10 15));
(= (+ 10 15) 25);

(define translate
  (? x
    (if (number? (x))
      (base-translate (x))
      (if (= (head (x)) vector)
        (translate
          (prepend
            ((list 2) list (list-length (tail (x))))
            (tail (x))))
        (base-translate (x))))));

(define translate-with-vector (translate));
(define translate-let-form
  (? x
    (? body
      (if (= (list-length (x)) 0)
        (translate (body))
        (translate-let-form
          (tail (x))
          (vector
            (vector ? (head (head (x))) (body))
            (head (tail (head (x))))))))));
(define translate
  (? x
    (if (number? (x))
      (translate-with-vector (x))
      (if (= (head (x)) let)
        (translate-let-form
          (head (tail (x)))
          (head (tail (tail (x)))))
        (translate-with-vector (x))))));

(define last
  (? x (list-ref (x) (- (list-length (x)) 1))));
(define except-last
  (? x
    (if (> (list-length (x)) 1)
      (prepend (head (x)) (except-last (tail (x))))
      (vector))));

(define prev-translate (translate));

(define translate
  (let ((prev (prev-translate)))
    (? x
      (if (number? (x))
        (prev (x))
        (if (= (head (x)) lambda)
          (let ((formals (head (tail (x))))
                (body (head (tail (tail (x))))))
            (if (> (list-length (formals)) 0)
              (translate
                (vector
                  lambda
                  (except-last (formals))
                  (vector ? (last (formals)) (body))))
              (translate (body))))
          (prev (x)))))));

(define prev-translate (translate));
(define reverse
  (? x
    (if (>= (list-length (x)) 1)
      (prepend (last (x)) (reverse (except-last (x))))
      (x))));
(list= (vector 1 2 3) (reverse (vector 3 2 1)));
(define translate
  (let ((prev (prev-translate)))
    (? x
      (if (number? (x))
        (prev (x))
        (if (= (head (x)) begin)
          (translate
            (vector
              (vector ? x (vector head (vector x)))
              (prepend vector (reverse (tail (x))))))
          (prev (x)))))));

(= (? x (- (x) 5)) (lambda (x) (- (x) 5)));

(define add-field
  (lambda (self name value)
    (? x
       (if (= (x) (name))
	   (value)
	   (self (x))))));

(define add-method
  (lambda (self name value this)
    (? x
       (if (= (x) (name))
	   (value (this))
	   (self (x))))));

(+ 5 55);

(define empty-object
  (lambda (x) 0));

(define make-object
  (let ((cell (make-cell (empty-object))))
    (lambda (x)
      (if (= (x) content)
	  (cell)
	  ((get! (cell)) (x))))));

(define add-field!
  (lambda (self name value)
    (set! (self content) (add-field (get! (self content)) (name) (value)))));

(define add-method!
  (lambda (self name value)
    (set! (self content) (add-method (get! (self content)) 
				     (name) 
				     (value)
				     (self)))));

(define test-obj (make-object));

(add-field! (test-obj) x 5);

(add-field! (test-obj) y 10);

(add-field! (test-obj) z 15);

(test-obj content);

(test-obj x);

(test-obj y);

(test-obj z);

(add-field! (test-obj) sum (lambda (self) (+ (self z) (self y))));

(add-method! (test-obj) sum2 (lambda (self) (+ (self z) (self y))));

((test-obj sum) (test-obj));

(test-obj sum2);

(add-field! (test-obj) z 90);

(test-obj sum2);

(define cloned
  (lambda (proto)
    (let ((cell (make-cell (empty-object))))
      (begin
	(set! (cell) (get! (proto content)))
	(lambda (x)
	  (if (= (x) content)
	      (cell)
	      ((get! (cell)) (x))))))));

(define test2 (cloned (test-obj)));

(test2 z);

(add-field! (test-obj) z 80);

(test2 z);

(add-field! (test2) z 80);

(test2 z);

(define maker
  (lambda (delay)
    (let ((self (make-object)))
      (begin
	(add-field! (self) x 5)
	(add-field! (self) y 10)
	(add-method! (self) xplusn (lambda (self n) (+ (self x) (n))))
	(add-method! (self) foo (lambda (self) (self)))
	(self)))));

(define foo1 (maker foo));

(define foo2 (maker foo));

(foo1 x);

(foo2 y);

(foo2 xplusn 4);

((foo2 foo) xplusn 1);


(define foomaker
  (lambda (self)
    (begin
      (add-field! (self) x 5)
      (add-field! (self) y 10)
      (add-method! (self) xplusn (lambda (self n) (+ (self x) (n))))
      (add-method! (self) foo (lambda (self) (self)))
      (self))));



(define barmaker
  (lambda (self)
    (begin
      (foomaker (self))
      (add-field! (self) z 88)
      (self))));


(define foo3 (barmaker (make-object)));

(foo3 x);

(foo3 z);

(lambda () 4);

(define first (? lst (head (lst))));
(define second (? lst (head (tail (lst)))));

(define make-integer
  (lambda (v)
    (lambda (x)
      (if (= (x) int)
	  (v)
	  0))));

(define objectify
  (? x 
     (if (number? (x))
	 (make-integer (x))
	 (x))));

(+ 1 932);

(define prev-translate (translate));

(define translate
  (let ((prev (prev-translate)))
    (? x
      (if (number? (x))
        (prev (x))
        (if (= (head (x)) lambda)
          (let ((formals (head (tail (x))))
                (body (head (tail (tail (x))))))
            (if (> (list-length (formals)) 0)
		(if (number? (last (formals)))
		    (translate
		     (vector
		      lambda
		      (except-last (formals))
		      (vector ? (last (formals)) (body))))
		    (let ((formal-name (first (last (formals))))
			  (formal-type (second (last (formals)))))
		      (translate
		       (vector
			lambda
			(except-last (formals))
			(vector 
			 ? 
			 (formal-name) 
			 (vector 
			  let
			  (vector (vector 
				   (formal-name) 
				   (vector
				    (vector objectify (vector (formal-name)))
				    (formal-type))))
			  (body)))))))
		(translate (body))))
          (prev (x)))))));

(intro t);
(intro T);

(+ 1 55510);

(define return
  (lambda (T t)
    (let ((obj (objectify (t))))
      (obj (T)))));

(define tester
  (lambda ((x int) (y int))
    (return int (+ (x) (y)))));


(tester (make-integer 10) (make-integer 32));

(tester 10 32);

  
(define flipmaker
  (lambda (self)
    (begin
      (add-field! (self) x 5)
      (add-field! (self) y 10)
      (add-method! (self) xplusn (lambda (self n) (+ (self x) (n))))
      (add-method! (self) flip (lambda (self) (self)))
      (self))));

(define f (flipmaker (make-object)));

((lambda ((q flip))
   (q x)) (f));


(define root-object
  (lambda (x)
    (if (= (x) add-field)
	(add-field!)
	(if (= (x) add-method)
	    (add-method!)
	    0))));



(define prev-translate (translate));
(define translate
  (let ((prev (prev-translate)))
    (? x
      (if (number? (x))
        (prev (x))
        (if (= (head (x)) cond)
          (let ((cnd (head (tail (x))))
                (rem (tail (tail (x)))))
            (if (> (list-length (rem)) 0)
		(translate
		 (vector
                  if
		  (first (cnd))
		  (second (cnd))
		  (prepend cond (rem))))
		(translate (cnd))))
          (prev (x)))))));

(cond 99);

(cond ((true) 8) 11);

(cond ((false) 3) ((false) 8) 11);

(define reflective
  (lambda (f)
    ((lambda (x)
       (f (lambda (y) ((x (x)) (y)))))
     (lambda (x)
       (f (lambda (y) ((x (x)) (y))))))));

(define point
  (lambda (x y)
    (reflective
     (lambda (self msg)
       (cond ((= (msg) x) (x))
	     ((= (msg) y) (y))
	     ((= (msg) point) (self))
	     ((= (msg) +) 
	      (lambda ((p point))
		(point (+ (x) (p x))
		       (+ (y) (p y)))))
	     ((= (msg) =) 
	      (lambda ((p point))
		(and (= (x) (p x))
		     (= (y) (p y)))))
	     0)))));

(define point1 (point 1 11));
(define point2 (point 2 22));
(= 1 (point1 x));
(= 22 (point2 y));
(= 11 ((point 11 12) x));
(= 11 (((point 11 12) point) x));
(= 16 (((point 16 17) point) x));
(= 33 (point1 + (point2) y));
(point1 + (point2) = (point 3 33));
(point2 + (point1) = (point 3 33));
((point 100 200) + (point 200 100) = (point 300 300));

(define instanceof
  (lambda (T t)
    (if (number? (t))
	(= (T) int)
	(not (number? ((objectify (t)) (T)))))));

(instanceof point (point1));
(not (instanceof int (point1)));
(instanceof int 5);
(not (instanceof point 5));

(define remove-match 
  (lambda (test lst)
    (if (> (list-length (lst)) 0)
	(if (test (head (lst)))
	    (remove-match (test) (tail (lst)))
	    (prepend (head (lst)) (remove-match (test) (tail (lst)))))
	(lst))));

(define remove-element
  (lambda (x) 
    (remove-match (lambda (y) (= (y) (x))))));

(list= (vector 1 2 3 5) (remove-element 4 (vector 1 2 3 4 5)));
(list= (vector 1 2 3 5) (remove-element 4 (vector 1 4 2 4 3 4 5)));

(+ 54 55);

(define list-find-helper
  (? lst
    (? key
      (? fail
        (? idx
          (if (= (list-length (lst)) 0)
            (fail 0)
            (if (= (head (lst)) (key))
              (idx)
              (list-find-helper
                (tail (lst))
                (key)
                (fail)
                (+ (idx) 1)))))))));
(define list-find
  (? lst
    (? key
      (? fail (list-find-helper (lst) (key) (fail) 0)))));
(define element
  (? x
    (? lst
      (not (= (list-find (lst) (x) (? y (false))) (false))))));
(define set-subset
  (? x
    (? y
      (if (> (list-length (x)) 0)
        (and (element (head (x)) (y))
             (set-subset (tail (x)) (y)))
        (true)))));
(define set=
  (? x
    (? y
      (and (set-subset (x) (y)) (set-subset (y) (x))))));

(+ 54 55);

(define create
  (lambda (x)
    (x new)));

(define container
  (lambda (id)
    (let ((contents (make-cell (vector))))
      (reflective
       (lambda (self msg)
	 (cond ((= (msg) container) (self))
	       ((= (msg) inventory) (get! (contents)))
	       ((= (msg) id) (id))
	       ((= (msg) add)
		(lambda (x) 
		  (if (not (element (x) (get! (contents))))
		      (set! (contents) (prepend (x) (get! (contents))))
		      (false))))
	       ((= (msg) remove)
		(lambda (x)
		  (set! (contents) (remove-element (x) (get! (contents))))))
	       ((= (msg) =)
		(lambda ((c container))
		  (set= (self inventory) (c inventory))))
	       0))))));

(define pocket (container new));

(pocket add 77);
(pocket add 88);
(pocket add 99);
(set= (pocket inventory) (vector 77 88 99));
(pocket remove 88);
(set= (pocket inventory) (vector 77 99));

(define pocket2 (container new));
(pocket2 add 77);
(pocket2 add 99);
(pocket2 = (pocket));

(define map
  (lambda (p lst)
    (if (> (list-length (lst)) 0)
      (prepend (p (head (lst))) (map (p) (tail (lst))))
      (vector))));

(define counter-container
  (lambda (x)
    (let ((super (container new)))
      (reflective
       (lambda (self msg)
	 (cond ((= (msg) counter-container) (self))
	       ((= (msg) count) (list-length (super inventory)))
	       (super (msg))))))));

(define cc1 (counter-container new));

(= 0 (cc1 count));
(cc1 add 4);
(= 1 (cc1 count));
(cc1 add 5);
(= 2 (cc1 count));

(define trivial-inheritance
  (lambda (name parent)
    (lambda (x)
      (let ((super (parent (x))))
	(reflective
	 (lambda (self msg)
	   (cond ((= (msg) (name)) (self))
		 (super (msg)))))))));

(define room (trivial-inheritance room (container)));

(define mud (trivial-inheritance mud (container)));

(define door
  (lambda ((src room) (dest room))
    (let ((obj
	   (reflective
	    (lambda (self msg)
	      (cond ((= (msg) door) (self))
		    ((= (msg) link) (pair (src) (dest)))
		    ((= (msg) construct) 
		     (begin (src add (self))
			    (dest add (self))))
		    0)))))
      (begin
	(obj construct)
	(obj)))));

(define hall (room hall));

(+ 1000 5);

(hall inventory);
(hall add 4);
(hall inventory);

(define kitchen (room kitchen));
(define door1 (door (hall) (kitchen)));


(+ 1000 hall);
(+ 1000 kitchen);

(hall inventory);

(first (hall inventory));

(map (? x (x id)) (first (hall inventory) link));

(define unique
  (let ((store (make-cell 0)))
    (lambda (x)
      (let ((id (get! (store))))
	(begin
	  (set! (store) (+ (id) 1))
	  (id))))));

(= (unique new) 0);

(= (unique new) 1);

(= (unique new) 2);

(not (= (unique new) (unique new)));


(define select-match 
  (lambda (test lst)
    (if (> (list-length (lst)) 0)
	(if (test (head (lst)))
	    (prepend (head (lst)) (select-match (test) (tail (lst))))
	    (select-match (test) (tail (lst))))
	(lst))));

(define append
  (? x
     (? lst
	(if (> (list-length (lst)) 0)
	    (prepend (head (lst)) (append (x) (tail (lst))))
	    (vector (x))))));

(append 5 (vector 1 2));

(define list-append
  (lambda (lst1 lst2)
    (if (> (list-length (lst1)) 0)
	(list-append (except-last (lst1))
		     (prepend (last (lst1)) (lst2)))
	(lst2))));

(list-append (vector 1 2 3) (vector 4 5 6));

(define prev-translate (translate));
(define translate
  (let ((prev (prev-translate)))
    (? x
       (if (number? (x))
	   (prev (x))
	   (if (= (head (x)) class)
	       (let ((name (list-ref (x) 1))
		     (args (list-ref (x) 2))
		     (fields (tail (tail (tail (x))))))
		 (translate
		  (vector
		   define
		   (name)
		   (vector
		    lambda
		    (prepend method (args))
		    (vector
		     let
		     (append
		      (vector unique-id (vector unique new))
		      (map 
		       (tail)
		       (select-match (? x (= (first (x)) field)) (fields))))
		     (vector
		      let
		      (vector
		       (vector
			self
			(vector
			 reflective
			 (vector
			  lambda
			  (vector self method)
			  (list-append
			   (prepend
			    cond
			    (list-append
			     (map
			      (? x 
				 (vector
				  (vector = (vector method) (first (x)))
				  (second (x))))
			      (map (tail)
				   (select-match 
				    (? x (= (first (x)) method)) 
				    (fields))))
			     (map
			      (? x 
				 (vector
				  (vector = (vector method) (x))
				  (vector (x))))
			      (map (second)
				   (select-match 
				    (? x (= (first (x)) field)) 
				    (fields))))))
			   (vector
			    (vector
			     (vector = (vector method) self)
			     (vector self))
			    (vector
			     (vector = (vector method) (name))
			     (vector self self))
			    (vector
			     (vector = (vector method) unknown)
			     (vector lambda (vector x) 0))
			    (vector
			     (vector = (vector method) new)
			     0)
			    (vector
			     (vector = (vector method) unique-id)
			     (vector unique-id))
			    (vector
			     (vector = (vector method) ==)
			     (vector
			      lambda
			      (vector x)
			      (vector = 
				      (vector unique-id)
				      (vector x unique-id))))
			    (vector self unknown (vector method))))))))
		      (vector 
		       begin
		       (vector self (vector method))
		       (vector self))))))))
	       (prev (x)))))));


(class point (x y) 
       (method x (x))
       (method y (y))
       (method + (lambda ((p point))
		   (point new 
			  (+ (x) (p x))
			  (+ (y) (p y)))))
       (method = (lambda ((p point))
		   (and (= (x) (p x))
			(= (y) (p y))))));

(define point1 (point new 3 10));
(define point2 (point new 10 3));

(point1 x);
(point1 y);
(point1 + (point2) x);
(point1 + (point2) y);

(class cell (initial-value)
       (field content (make-cell (initial-value)))
       (method get (get! (content)))
       (method set (lambda (new-value)
		     (set! (content) (new-value))))
       (method reset (self set (initial-value)))
       (method unknown (lambda (x) ((objectify (self get)) (x)))));

(define cell-test1 (cell new 15));
(= 15 (cell-test1 get));
(cell-test1 set 82);
(= 82 (cell-test1 get));

(define cell-test2 (cell new (point new 120 150)));
(define cell-test3 (cell new (point new 300 300)));
(cell-test2 + (cell-test3) = (point new 420 450));

(define mutable 
  (lambda (x)
    (cell new (x))));

(cell-test1 == (cell-test1));
(not (cell-test1 == (cell-test2)));
(not (cell-test2 == (cell-test1)));
(cell-test2 == (cell-test2));

(class mutable-point (ix iy)
       (field nn (mutable 55))
       (field xx (mutable (ix)))
       (field yy (mutable (iy)))
       (method new (nn set 88))
       (method set (lambda (x1 y1)
		     (begin
		       (self xx set (x1))
		       (self yy set (y1)))))
       (method similar (lambda ((p mutable-point))
			 (and (= (self xx get) (p xx get))
			      (= (self yy get) (p yy get))))));


(define mcell-test1 (mutable-point new 5 10));
(define mcell-test2 (mutable-point new 10 5));
(mcell-test1 similar (mcell-test1));
(mcell-test1 similar (mcell-test2));
(mcell-test1 set 10 5);
(mcell-test1 similar (mcell-test2));
(mcell-test1 nn get);


(define object-element
  (lambda (n lst)
    (> (list-length 
	(select-match (lambda (x) (x == (n))) (lst))) 
       0)));

(class container ()
    (field contents (cell new (vector)))
    (method inventory (contents get))
    (method add (lambda (x) 
		  (if (not (object-element (x) (contents get)))
		      (contents set (prepend (x) (contents get)))
		      (false)))));

(class door ((src room) (dest room))
       (method new (begin
		     (src add (self))
		     (dest add (self))))
       (method access-from (lambda ((current room))
			     (cond ((current == (src)) (dest))
				   ((current == (dest)) (src))
				   0)))
       (method is-present (lambda ((current room))
			    (cond ((current == (src)) (true))
				  ((current == (dest)) (true))
				  (false)))));

(+ 1 8000);
(define c (container new));
(c add (door new));

(class room ()
       (field content (container new))
       (method unknown (lambda (x) (content (x)))));

(define hall (room new));
(define kitchen (room new));
(define lawn (room new));
(define stairs (room new));
(define bedroom (room new));
(define door1 (door new (hall) (kitchen)));
(define door2 (door new (hall) (lawn)));
(define door3 (door new (hall) (stairs)));
(define door4 (door new (stairs) (bedroom)));
(define nowhere (room new));

(door1 access-from (hall) == (kitchen));
(not (door1 access-from (hall) == (hall)));
(door1 access-from (kitchen) == (hall));

(class character ()
       (field location (cell new (nowhere)))
       (method set-room (lambda ((r room)) (location set (r))))
       (method get-room (location get))
       (method update 0));

(define find-max-helper
  (lambda (test max idx n lst)
    (if (> (list-length (lst)) 0)
	(if (> (test (head (lst))) (max))
	    (find-max-helper (test) (test (head (lst))) (n) (+ (n) 1) (tail (lst)))
	    (find-max-helper (test) (max) (idx) (+ (n) 1) (tail (lst))))
	(idx))));

(define find-max-idx
  (lambda (test lst)
    (find-max-helper (test) (test (head (lst))) 0 0 (lst))));

(define find-min-helper
  (lambda (test max idx n lst)
    (if (> (list-length (lst)) 0)
	(if (< (test (head (lst))) (max))
	    (find-min-helper (test) (test (head (lst))) (n) (+ (n) 1) (tail (lst)))
	    (find-min-helper (test) (max) (idx) (+ (n) 1) (tail (lst))))
	(idx))));

(define find-min-idx
  (lambda (test lst)
    (find-min-helper (test) (test (head (lst))) 0 0 (lst))));

(= 2 (find-max-idx (lambda (x) (x)) (vector 3 4 5 0)));

(= 1 (find-max-idx (lambda (x) (x)) (vector 3 5 4 0)));

(= 0 (find-max-idx (lambda (x) (x)) (vector 5 3 4 0)));

(class robo ()
       (field super (character new))
       (field timestamp (cell new 0))
       (field timestamp-map (cell new (lambda (x) 0)))
       (method unknown (lambda (x) (super (x))))
       (method update 
	       (let ((exits 
		      (select-match (lambda (x) (instanceof door (x)))
				    (self location inventory))))
		 (let ((timestamps
			(map (lambda (x) (timestamp-map get (x)))
			     (exits))))
		   (let ((chosen-exit (list-ref 
				       (exits)
				       (find-min-idx (lambda (x) (x))
						     (timestamps))))
			 (current-tmap (timestamp-map get))
			 (current-t (timestamp get)))
		     (begin
		       (self location set (chosen-exit 
					   access-from 
					   (self location get)))
		       (timestamp-map set 
				      (lambda ((d door))
					(if (d == (chosen-exit))
					    (current-t)
					    (current-tmap (d)))))
		       (timestamp set (+ (timestamp get) 1))))))));


(define myrobo (robo new));

(myrobo set-room (stairs));

(define which-room
  (lambda ((rr robo))
    (find-max-idx 
     (lambda ((r room)) (if (r == (rr get-room)) 1 0))
     (vector (hall) (kitchen) (stairs) (lawn) (bedroom)))));

(define sequencer
  (lambda (n current lst)
    (if (< (current) (n))
	(begin
	  (myrobo update)
	  (sequencer
	   (n)
	   (+ (current) 1)
	   (append
	    (which-room (myrobo))
	    (lst))))
	(lst))));

(sequencer 30 0 (vector));

(list= (sequencer 30 0 (vector)) (vector 0 3 0 1 0 2 4 2 0 3 0 1 0 2 4 2 0 3 0 1 0 2 4 2 0 3 0 1 0 2));

